	PROGRAM BT3_5
	PARAMETER (NMAX=100)
	DIMENSION X(NMAX)
	INTEGER NAM(NMAX),N,I,N1
	REAL A,B,P1,P2,X95, P20_25,X05
	REAL TB,SX

	OPEN(1,FILE='C:\MASTER\G_TR\BAITAP~1\NEW\BANG3.TXT')
	READ(1,*)
	READ(1,*)
	READ(1,*)N
      READ(1,*)((NAM(I),X(I)), I=1,N)
	
	TB=AMMGOC(X,N,1)
	SX=SQRT(AMMTAM(X,N,2))
! TINH XAC SUAT T7<20
	P1=FNORMD(TB,SX,28.0)
! XAC SUAT T7>30
	P2=1.0-FNORMD(TB,SX,30.0)
! GIA TRI X95 CUA X UNG VOI P(X<X95)=0.95
	X95=ANINV(0.95,TB,SX)

	WRITE(*,'("   MUY= ",F8.2,"   XICMA= ",F8.2)')TB,SX
	WRITE(*,'(" XAC SUAT P(T7<20):          ",F8.4)') P1
	WRITE(*,'(" XAC SUAT P(T7>30):          ",F8.4)') P2
	WRITE(*,'(" X95 UNG VOI P(T7<X95)=0.95: ",F8.4)') X95
	WRITE(*,*)
! NEU X CO KY VONG =22.5 VA PHUONG SAI =1:
	TB=22.5
	SX=1.0
! GIA TRI X05 CUA X UNG VOI P(X>X05)=0.05=1-P(X<X05)
	X05=ANINV(0.95,TB,SX)
! XAC SUAT P(20<X<25)
	P20_25=ANORMD(TB,SX, 20.0, 25.0)
	WRITE(*,'("   MUY= ",F8.2,"   XICMA= ",F8.2)')TB,SX
	WRITE(*,'(" XAC SUAT P(20<T7<25):       ",F8.4)') P20_25
	WRITE(*,'(" X05 UNG VOI P(T7>X05)=0.05: ",F8.4)') X05
	END

	FUNCTION FNORMD(TB,SX,X0)
! HAM NAY TINH GIA TRI HAM PHAN BO CUA BIEN NGAU NHIEN 
! PHAN BO CHUAN CO KY VONG = TB, PHUONG SAI =SX**2
! FNORMD = F(X<X0)
	REAL TB,SX,X,P1
	IF (TB.EQ.X0) THEN
	   P1=0.5
	ELSE IF (TB.GT.X0) THEN
	   P1=0.5-ANORMD(TB,SX,X0,TB)
	ELSE
	   P1=0.5+ANORMD(TB,SX,TB,X0)
	ENDIF
	FNORMD=P1
	RETURN
	END

	FUNCTION ANORMD(AMUY,XICMA,A,B)
! HAM NAY TINH XAC SUAT DE BIEN NGAU NHIEN PHAN BO CHUAN
! NHAN GIA TRI TRONG KHOANG (A,B): P(A<X<B). THUC CHAT
! HAM NAY LA TINH TICH PHAN TU A-B
! INPUT: + MUY KY VONG TOAN
!        + XICMA DO LECH BINH PHUONG TRUNG BINH
!        + A VA B LA HAI CAN TICH PHAN.
! OUTPUT: P(A<X<B)
!
	  REAL AMUY,XICMA,A,B,C
	  PARAMETER(PI=3.1415927,EP=1.0E-6)
	  F(X)=1.0/(SQRT(2.0*PI)*XICMA)*EXP(-0.5*((X-AMUY)/XICMA)**2)
	  IF (A.EQ.B) THEN
	     ANORMD=0.0
		 RETURN
	  ENDIF
	  IF (A.GT.B) THEN
	     C=A
		 A=B
		 B=C
	  ENDIF
	  S=0.0
	  N=0
  10  N=N+1
      DELX=(B-A)/REAL(N)
	  S1=0.0
	  DO I=0,N-1
	     X=A+DELX*REAL(I)
		 F1=F(X)
		 X=X+DELX
		 F2=F(X)
		 S1=S1+(F1+F2)*DELX/2.0
	  ENDDO
	  SS=ABS((S1-S)/S1)
	  IF (SS.GT.EP) THEN
	     S=S1
		 GOTO 10
	  ENDIF
      ANORMD=S1
	  RETURN
	  END

	FUNCTION ANINV(P,MUY,XICMA)
! HAM NAY TINH GIA TRI X0 CUA BIEN NGAU NHIEN X PHAN BO CHUAN
! VOI HAI THAM SO MUY VA XICMA KHI P(X<X0)=P.
! KHI TINH SE SU DUNG BIEN PHAN BO CHUAN CHUAN HOA
! INPUT: + P XAC SUAT DE X<X0 (P(X<X0)=P)
!        + MUY KY VONG CUA X
!        + XICMA DO LECH BINH PHUONG TRUNG BINH
! OUTPUT: X0
!
	  PARAMETER (EPS=1.0E-6)
	  REAL P,AP,MUY,XICMA,A,B,C,P0
	  INTEGER IFLAG
	  IF (P.EQ.0.0) THEN
	     WRITE(*,*)' THE P VALUE TOO SMALL IN ANINV'
		 STOP
	  ELSE IF (P.EQ.0.5) THEN
	     ANINV=MUY
		 RETURN
	  ENDIF
!
	  IF (P.LT.0.5) THEN
	     AP=0.5-P
		 IFLAG=1
	  ELSE IF (P.GT.0.5) THEN
		 AP=P-0.5
		 IFLAG=0
		 PRINT*,P,A,B
	  ENDIF
	  A=0.0
	  B=6.0
	  C=B
	  PRINT*,P,A,B,C

 10	  P0=ANORMD(0.0,1.0,A,B)
	  SS=(ABS(P0-AP)/AP)
	  IF (SS.GE.EPS) THEN
	     IF (AP.LT.P0) THEN
		    C=B
			B=(A+B)/2.0
			GOTO 10
		  ELSE IF (AP.GT.P0) THEN
			B=(C+B)/2.0
			GOTO 10
		  ENDIF
	  ENDIF
	  A=(C+B)/2.0
	  IF (IFLAG.EQ.1) THEN
 	     ANINV=-A*XICMA+MUY
	  ELSE
         ANINV=A*XICMA+MUY
	  ENDIF
	  RETURN
	  END

	  FUNCTION AMMGOC(X,N,K)
!
! HAM NAY TINH MOMEN GOC BAC K CUA CHUOI SO LIEU
! INPUT: + X MANG SO LIEU BAN DAU DO DAI N
!        + N DUNG LUONG MAU
!        + K BAC CUA MOMEN
! OUTPUT: MOMEN GOC BAC K
!
      DIMENSION X(N)
	  INTEGER N,K,I
	  REAL TMP
	  TMP=0.0
	  DO I=1,N
	     TMP=TMP+X(I)**K
	  ENDDO
	  AMMGOC=TMP/REAL(N)
	  RETURN
	  END

	  FUNCTION FAC(N)
! TINH N! (N GIAI THUA)
	  REAL TMP
	  IF (N.LT.0) THEN
	     WRITE(*,*)' INVALID NUMERIC INPUT IN FAC FUNCTION'
		 STOP
	  ELSE IF (N.EQ.0.OR.N.EQ.1) THEN
	     FAC=1.0
		 RETURN
	  ELSE
	     TMP=1.0
		 DO I=2,N
	        TMP=TMP*REAL(I)
		 ENDDO
		 FAC=TMP
		 RETURN
	  ENDIF
	  END

      FUNCTION COMBIN(N,K)
! TINH TO HOP CHAP K CUA N
! FUNCTION/SUBROUTINE DUOC GOI TOI: FAC(N)
	  IF (N.LT.0.OR.K.LT.0.OR.N.LT.K) THEN
	     WRITE(*,*)' INVALID NUMERIC INPUT IN COMBIN FUNCTION'
		 STOP
      ELSE 
         COMBIN=FAC(N)/FAC(K)/FAC(N-K)
	     RETURN
	  ENDIF
	  END

	  FUNCTION AMMTAM(X,N,K)
! HAM NAY TINH MOMEN TRUNG TAM BAC K TU CHUOI SO LIEU X
! INPUT: + X MANG SO LIEU BAN DAU DO DAI N
!        + N DUNG LUONG MAU
!        + K BAC CUA MOMEN
! OUTPUT: MOMEN TRUNG TAM BAC K
! FUNCTION/SUBROUTINE DUOC GOI TOI: AMMGOC(X,N,K), COMBIN(N,K)
	  DIMENSION X(N)
	  INTEGER N,K,I
	  REAL TMP,TB
	  TB=AMMGOC(X,N,1)
	  TMP=0
	  DO I=0,K
	     TMP=TMP+(-1)**I*COMBIN(K,I)*TB**I*AMMGOC(X,N,K-I)
	  ENDDO
	  AMMTAM=TMP
	  RETURN
	  END
