	PROGRAM BT4_14
	PARAMETER (NMAX=100,MMAX=6)
	DIMENSION X(NMAX,MMAX), F(MMAX,MMAX)
	DIMENSION DX(MMAX)
	DIMENSION XX(NMAX*MMAX)
	REAL ALFA, FALFA
	CHARACTER *12, H0,H1, ANSWER(MMAX,MMAX)

	DATA ALFA /0.05/
	DATA H0,H1 /'CHAP NHAN H0','BAC BO H0'/

	OPEN(1,FILE='C:\MASTER\G_TR\BAITAP~1\NEW\BANG8.TXT')
	READ(1,*)
	READ(1,*)
	READ(1,*) N,M
	DO I=1,N
       READ(1,*) TMP, (X(I,J),J=1,M)
	ENDDO
	DO J=1,M
	DO I=1,N
	   XX(I)=X(I,J)
	ENDDO
	DX(J)=AMMTAM(XX,N,2)
	ENDDO
	FALFA=FINV(ALFA,REAL(N-1),REAL(N-1))

	DO J=1,M-1
	DO K=J+1,M
	   F(J,K)=DX(J)/DX(K)
	   IF (F(J,K).LT.1.0) F(J,K)=1.0/F(J,K)
	IF (ABS(F(J,K)).LT.FALFA) THEN 
	   ANSWER(J,K)=H0
	ELSE
	   ANSWER(J,K)=H1
	ENDIF
	ENDDO
	ENDDO

	DO J=1,M-1
	DO K=J+1,M
	WRITE(*,'(" KET QUA KIEM NGHIEM F - H0: D(",I1,")=D(",
     &           I1,")")')J,K
	WRITE(*,'("      F  = ",F10.3)') F(J,K)
	WRITE(*,'("     N1  = ",I10)') N
	WRITE(*,'("     N2  = ",I10)') N
	WRITE(*,'("   ALFA  = ",F10.3)') ALFA
	WRITE(*,'("  FALFA  = ",F10.3)') FALFA
	WRITE(*,'(" KET LUAN: ",A15)') ANSWER(J,K)
	PAUSE
	ENDDO
	ENDDO

	END
!++++++++++++++++++++++++++++
	  FUNCTION FINV(P,N1,N2)
! HAM NAY TINH GIA TRI X0 CUA BIEN NGAU NHIEN X PHAN BO 
! FISHER (F) VOI N1 VA N2 BAC TU DO THOA MAN DIEU KIEN 
! P(X>X0)=P.
! INPUT: + P XAC SUAT DE X>X0 (P(X>X0)=P)
!        + N1 VA N2 LA SO BAC TU DO, PHAI LA NHUNG SO THUC
! OUTPUT: X0
! SUBROUTINE/FUNCTION DUOC GOI TOI: FDIST
	  PARAMETER (EPS=1.0E-6)
	  REAL P,AP,N1,N2, A,B,C,P0,SS,SS1
	  IF (P.LT.0.0.OR.P.GT.1.0) THEN
	     WRITE(*,*)' INVALID NUMERIC INPUT IN FINV FUNCTION'
		 STOP
	  ENDIF
	  IF (P.EQ.0.0) THEN
		 WRITE(*,*)' THE P VALUE TOO SMALL IN FINV FUNCTION'
		 STOP
	  ELSE IF (P.EQ.1) THEN
	     FINV=0.0
		 RETURN
	  ENDIF
!
	  A=0.0
	  B=9999999.0
	  C=A
	  AP=P

 10	  P0=FDIST(B,N1,N2)
	  SS=ABS((P0-AP)/AP)
	  SS1=ABS((B-C)/B)
	  PRINT*,'P0=',P0,' SS=',SS,' B=',B,' C=',C
	  IF (SS.GE.EPS.AND.SS1.GE.EPS) THEN
	     IF (AP.GT.P0) THEN
		    C=B
			B=(A+B)/2.0
			GOTO 10
		  ELSE IF (AP.LT.P0) THEN
			B=(C+B)/2.0
			GOTO 10
		  ENDIF
	  ENDIF
	  A=(C+B)/2.0
      FINV=A
	  RETURN
	  END


	  FUNCTION FDIST(X0,N1,N2)
! HAM NAY TINH XAC SUAT DE BIEN NGAU NHIEN X CO PHAN BO FISHER
! VOI N1 VA N2 BAC TU DO NHAN GIA TRI >X0:
! P=P(X>X0)=1-P(X<X0)
! INPUT: + X0 MOT GIA TRI NAO DO CUA X
!        + N1,N2 SO BAC TU DO, PHAI LA NHUNG SO THUC
! SUBROUTINE/FUNCTION DUOC GOI TOI: BETAI
!
	  REAL X0,N1,N2,X
	  X=N2/(N2+N1*X0)
	  FDIST=BETAI(0.5*N2,0.5*N1,X)
	  RETURN
	  END 
      FUNCTION betai(a,b,x)
      REAL betai,a,b,x
!CU    USES betacf,gammln
      REAL bt,betacf,gammln
      if(x.lt.0..or.x.gt.1.)pause 'bad argument x in betai'
      if(x.eq.0..or.x.eq.1.)then
        bt=0.
      else
        bt=exp(gammln(a+b)-gammln(a)-gammln(b)+a*log(x)+b*log(1.-x))
      endif
      if(x.lt.(a+1.)/(a+b+2.))then
        betai=bt*betacf(a,b,x)/a
        return
      else
        betai=1.-bt*betacf(b,a,1.-x)/b
        return
      endif
      END

      FUNCTION betacf(a,b,x)
      INTEGER MAXIT
      REAL betacf,a,b,x,EPS,FPMIN
      PARAMETER (MAXIT=100,EPS=3.e-7,FPMIN=1.e-30)
      INTEGER m,m2
      REAL aa,c,d,del,h,qab,qam,qap
      qab=a+b
      qap=a+1.
      qam=a-1.
      c=1.
      d=1.-qab*x/qap
      if(abs(d).lt.FPMIN)d=FPMIN
      d=1./d
      h=d
      do 11 m=1,MAXIT
        m2=2*m
        aa=m*(b-m)*x/((qam+m2)*(a+m2))
        d=1.+aa*d
        if(abs(d).lt.FPMIN)d=FPMIN
        c=1.+aa/c
        if(abs(c).lt.FPMIN)c=FPMIN
        d=1./d
        h=h*d*c
        aa=-(a+m)*(qab+m)*x/((a+m2)*(qap+m2))
        d=1.+aa*d
        if(abs(d).lt.FPMIN)d=FPMIN
        c=1.+aa/c
        if(abs(c).lt.FPMIN)c=FPMIN
        d=1./d
        del=d*c
        h=h*del
        if(abs(del-1.).lt.EPS)goto 1
11    continue
      pause 'a or b too big, or MAXIT too small in betacf'
1     betacf=h
      return
      END

      FUNCTION gammln(xx)
      REAL gammln,xx
      INTEGER j
      DOUBLE PRECISION ser,stp,tmp,x,y,cof(6)
      SAVE cof,stp
      DATA cof,stp/76.18009172947146d0,-86.50532032941677d0,
     & 24.01409824083091d0,-1.231739572450155d0,.1208650973866179d-2, 
     & -.5395239384953d-5,2.5066282746310005d0/
      x=xx
      y=x
      tmp=x+5.5d0
      tmp=(x+0.5d0)*log(tmp)-tmp
      ser=1.000000000190015d0
      do 11 j=1,6
        y=y+1.d0
        ser=ser+cof(j)/y
11    continue
      gammln=tmp+log(stp*ser/x)
      return
      END

	  FUNCTION AMMGOC(X,N,K)
!
! HAM NAY TINH MOMEN GOC BAC K CUA CHUOI SO LIEU
! INPUT: + X MANG SO LIEU BAN DAU DO DAI N
!        + N DUNG LUONG MAU
!        + K BAC CUA MOMEN
! OUTPUT: MOMEN GOC BAC K
!
      DIMENSION X(N)
	  INTEGER N,K,I
	  REAL TMP
	  TMP=0.0
	  DO I=1,N
	     TMP=TMP+X(I)**K
	  ENDDO
	  AMMGOC=TMP/REAL(N)
	  RETURN
	  END

	  FUNCTION FAC(N)
! TINH N! (N GIAI THUA)
	  REAL TMP
	  IF (N.LT.0) THEN
	     WRITE(*,*)' INVALID NUMERIC INPUT IN FAC FUNCTION'
		 STOP
	  ELSE IF (N.EQ.0.OR.N.EQ.1) THEN
	     FAC=1.0
		 RETURN
	  ELSE
	     TMP=1.0
		 DO I=2,N
	        TMP=TMP*REAL(I)
		 ENDDO
		 FAC=TMP
		 RETURN
	  ENDIF
	  END

      FUNCTION COMBIN(N,K)
! TINH TO HOP CHAP K CUA N
! FUNCTION/SUBROUTINE DUOC GOI TOI: FAC(N)
	  IF (N.LT.0.OR.K.LT.0.OR.N.LT.K) THEN
	     WRITE(*,*)' INVALID NUMERIC INPUT IN COMBIN FUNCTION'
		 STOP
      ELSE 
         COMBIN=FAC(N)/FAC(K)/FAC(N-K)
	     RETURN
	  ENDIF
	  END

	  FUNCTION AMMTAM(X,N,K)
! HAM NAY TINH MOMEN TRUNG TAM BAC K TU CHUOI SO LIEU X
! INPUT: + X MANG SO LIEU BAN DAU DO DAI N
!        + N DUNG LUONG MAU
!        + K BAC CUA MOMEN
! OUTPUT: MOMEN TRUNG TAM BAC K
! FUNCTION/SUBROUTINE DUOC GOI TOI: AMMGOC(X,N,K), COMBIN(N,K)
	  DIMENSION X(N)
	  INTEGER N,K,I
	  REAL TMP,TB
	  TB=AMMGOC(X,N,1)
	  TMP=0
	  DO I=0,K
	     TMP=TMP+(-1)**I*COMBIN(K,I)*TB**I*AMMGOC(X,N,K-I)
	  ENDDO
	  AMMTAM=TMP
	  RETURN
	  END
