	PROGRAM BT4_8
      PARAMETER (NMAX=100,MMAX=12)
	DIMENSION X(NMAX,MMAX),Y(NMAX,MMAX)
	REAL MUY1,MUY2,XICMA, ALFA,U,UALFA
	INTEGER NX,NY,M,I,J
	CHARACTER*15 H0,H1,ANSWER1,ANSWER2
! XICMA: DO LECH CHUAN CUA X
! ALFA: XAC SUAT PHAM SAI LAM LOAI I
	DATA XICMA,ALFA /0.4,0.05/
	DATA H0,H1 /'CHAP NHAN H0','BAC BO H0'/

	OPEN(1,FILE='C:\MASTER\G_TR\BAITAP~1\NEW\BANG11-B.TXT')
	READ(1,*)
	READ(1,*)
	READ(1,*) NX,M
	DO I=1,NX
         READ(1,*) TMP, (X(I,J),J=1,M)
	ENDDO

	OPEN(1,FILE='C:\MASTER\G_TR\BAITAP~1\NEW\BANG11-C.TXT')
	READ(1,*)
	READ(1,*)
	READ(1,*) NY,M
	DO I=1,NY
         READ(1,*) TMP, (Y(I,J),J=1,M)
	ENDDO

! TINH TRUNG BINH SO HOC
	MUY1=0.0
	DO I=1,NX
	DO J=1,M
	   MUY1=MUY1+X(I,J)
	ENDDO
	ENDDO
	MUY1=MUY1/REAL(NX*M)

	MUY2=0.0
	DO I=1,NY
	DO J=1,M
	   MUY2=MUY2+Y(I,J)
	ENDDO
	ENDDO
	MUY2=MUY2/REAL(NY*M)

! TINH U VA UALFA
	U=(MUY1-MUY2)/(XICMA*SQRT(1.0/REAL(NX)+1.0/REAL(NY)))
	UALFA=ANINV(1.0-ALFA/2.0,0.0,1.0)
	IF (ABS(U).LT.UALFA) THEN 
	   ANSWER1=H0
	ELSE
	   ANSWER1=H1
	ENDIF
	WRITE(*,*)' KET QUA KIEM NGHIEM U - H0: MUY1=MUY2'
	WRITE(*,'("   MUY1  = ",F10.3)') MUY1
	WRITE(*,'("   MUY2  = ",F10.3)') MUY2
	WRITE(*,'("     N1  = ",I10)') NX
	WRITE(*,'("     N2  = ",I10)') NY
	WRITE(*,'("      U  = ",F10.3)') U
	WRITE(*,'("   ALFA  = ",F10.3)') ALFA
	WRITE(*,'("  UALFA  = ",F10.3)') UALFA
	WRITE(*,'(" KET LUAN: ",A15)') ANSWER1

	END

	FUNCTION ANORMD(AMUY,XICMA,A,B)
! HAM NAY TINH XAC SUAT DE BIEN NGAU NHIEN PHAN BO CHUAN
! NHAN GIA TRI TRONG KHOANG (A,B): P(A<X<B). THUC CHAT
! HAM NAY LA TINH TICH PHAN TU A-B
! INPUT: + MUY KY VONG TOAN
!        + XICMA DO LECH BINH PHUONG TRUNG BINH
!        + A VA B LA HAI CAN TICH PHAN.
! OUTPUT: P(A<X<B)
!
	  REAL AMUY,XICMA,A,B,C
	  PARAMETER(PI=3.1415927,EP=1.0E-6)
	  F(X)=1.0/(SQRT(2.0*PI)*XICMA)*EXP(-0.5*((X-AMUY)/XICMA)**2)
	  IF (A.EQ.B) THEN
	     ANORMD=0.0
		 RETURN
	  ENDIF
	  IF (A.GT.B) THEN
	     C=A
		 A=B
		 B=C
	  ENDIF
	  S=0.0
	  N=0
  10  N=N+1
      DELX=(B-A)/REAL(N)
	  S1=0.0
	  DO I=0,N-1
	     X=A+DELX*REAL(I)
		 F1=F(X)
		 X=X+DELX
		 F2=F(X)
		 S1=S1+(F1+F2)*DELX/2.0
	  ENDDO
	  SS=ABS((S1-S)/S1)
	  IF (SS.GT.EP) THEN
	     S=S1
		 GOTO 10
	  ENDIF
      ANORMD=S1
	  RETURN
	  END

	FUNCTION ANINV(P,MUY,XICMA)
! HAM NAY TINH GIA TRI X0 CUA BIEN NGAU NHIEN X PHAN BO CHUAN
! VOI HAI THAM SO MUY VA XICMA KHI P(X<X0)=P.
! KHI TINH SE SU DUNG BIEN PHAN BO CHUAN CHUAN HOA
! INPUT: + P XAC SUAT DE X<X0 (P(X<X0)=P)
!        + MUY KY VONG CUA X
!        + XICMA DO LECH BINH PHUONG TRUNG BINH
! OUTPUT: X0
!
	  PARAMETER (EPS=1.0E-6)
	  REAL P,AP,MUY,XICMA,A,B,C,P0
	  INTEGER IFLAG
	  IF (P.EQ.0.0) THEN
	     WRITE(*,*)' THE P VALUE TOO SMALL IN ANINV'
		 STOP
	  ELSE IF (P.EQ.0.5) THEN
	     ANINV=MUY
		 RETURN
	  ENDIF
!
	  IF (P.LT.0.5) THEN
	     AP=0.5-P
		 IFLAG=1
	  ELSE IF (P.GT.0.5) THEN
		 AP=P-0.5
		 IFLAG=0
		 PRINT*,P,A,B
	  ENDIF
	  A=0.0
	  B=6.0
	  C=B
	  PRINT*,P,A,B,C

 10	  P0=ANORMD(0.0,1.0,A,B)
	  SS=(ABS(P0-AP)/AP)
	  IF (SS.GE.EPS) THEN
	     IF (AP.LT.P0) THEN
		    C=B
			B=(A+B)/2.0
			GOTO 10
		  ELSE IF (AP.GT.P0) THEN
			B=(C+B)/2.0
			GOTO 10
		  ENDIF
	  ENDIF
	  A=(C+B)/2.0
	  IF (IFLAG.EQ.1) THEN
 	     ANINV=-A*XICMA+MUY
	  ELSE
         ANINV=A*XICMA+MUY
	  ENDIF
	  RETURN
	  END
