
	PROGRAM BT1_13
	PARAMETER (NMAX=100)
	REAL X(NMAX),NFR(NMAX),FR(NMAX),XC(NMAX),F(NMAX)
	INTEGER NAM(NMAX)
	INTEGER N,INTERVAL,M,I
	REAL XMIN,STEP, FA,FB,PAB
	REAL A,B, R5,R10,R75,R90, F0,ALFA

	OPEN(1,FILE='C:\MASTER\G_TR\BAITAP~1\NEW\BANG1.TXT')
	READ(1,*)
	READ(1,*)
	READ(1,*)N
      READ(1,*)((NAM(I),X(I)), I=1,N)
	
	INTERVAL=0
!
! TINH HAM PHAN BO FR VA HAM MAT DO F VOI XC
! LA TRI SO GIUA CAC KHOANG CO BUOC BANG STEP
!
	CALL FREQ(X,N,XC,FR,F,NFR,M,XMIN,STEP,INTERVAL)
! TINH XAC SUAT P(A<R<B)	
	A=1900.0
	B=2200.0
	FB = PROB(FR,XC,M,STEP,B)
	FA = PROB(FR,XC,M,STEP,A)
	PAB = FB-FA
	
	WRITE(*,*)' HAM PHAN BO (FR) VA HAM MAT DO (F)'
	WRITE(*,*)' I ','   XC  ','    FR  ','    F  '

	DO I=1,M
	   WRITE(*,'(I3,F7.1,3F8.4)') I,XC(I),FR(I),F(I)
	ENDDO
	WRITE(*,*)
	WRITE(*,'(" XS R THUOC (",F6.1,",",F6.1,") =",F8.4)') A,B,PAB
	WRITE(*,*)
	
! TINH R UNG VOI CAC SUAT BAO DAM KHAC NHAU
	ALFA=0.05
	F0  = 1.0-ALFA
	R5  = X_ALFA(FR,XC,M,STEP,F0)
	WRITE(*,'(" R UNG VOI SBD ALFA=",F6.3," LA ",F8.1)') ALFA,R5
	ALFA=0.10
	F0  = 1.0-ALFA
	R10 = X_ALFA(FR,XC,M,STEP,F0)
	WRITE(*,'(" R UNG VOI SBD ALFA=",F6.3," LA ",F8.1)') ALFA,R10
	ALFA=0.75
	F0  = 1.0-ALFA
	R75 = X_ALFA(FR,XC,M,STEP,F0)
	WRITE(*,'(" R UNG VOI SBD ALFA=",F6.3," LA ",F8.1)') ALFA,R75
	ALFA=0.90
	F0  = 1.0-ALFA
	R90 = X_ALFA(FR,XC,M,STEP,F0)
	WRITE(*,'(" R UNG VOI SBD ALFA=",F6.3," LA ",F8.1)') ALFA,R90
	END


	SUBROUTINE FREQ(X,N,XC,FR,F,NFR,M,XMIN,STEP,INTERVAL)
C
C  CHUONG TRINH NAY TINH TAN SO (NFR) VA TAN SUAT (FR)
C  CUA MANG X DO DAI N.
C INPUT:  + MANG X CHUA GIA TRI QUAN TRAC CUA BIEN NGAU NHIEN
C         + N LA DUNG LUONG MAU
C         + INTERVAL = 0 NEU LAY SO KHOANG CHIA NGAM DINH
C                    = 1 NEU TU CHON SO KHOANG CHIA 
C OUTPUT: + M LA SO KHOANG CHIA, KHI INTERVAL = 0 THI
C           M = 5*LOG10(N)
C         + XC MANG DO DAI M CHUA TRI SO TRUNG GIAN CUA CAC KHOANG
C         + NFR MANG DO DAI M CHUA TAN SO CAC NHOM
C         + FR MANG DO DAI M CHUA TAN SUAT TICH LUY CAC NHOM (HAM PHAN BO)
C         + F MANG DO DAI M CHUA MAT DO XAC SUAT CAC NHOM
C         + XMIN GIOI HAN DUOI CUA NHOM THU NHAT (<=MIN{X(I)}
C         + STEP BUOC CHIA
C
      REAL X(1),NFR(1),FR(1),XC(1),F(1)
	INTEGER N,INTERVAL,M
	REAL XMIN,XMAX,STEP
	CHARACTER ST*10
C	   
      IF (INTERVAL.EQ.0) THEN
	     M=5*LOG10(REAL(N))
	  ELSE
 10	     WRITE(*,'(A\)') ' CHO SO KHOANG: '
		 READ*, ST
		 READ(ST,*,ERR=100) M
		 GOTO 101
 100     PRINT*,' INVALID NUMERIC INPUT ! AGAIN...'
         GOTO 10
 101     CONTINUE
      ENDIF
C
C  XAC DINH MAX, MIN CUA CHUOI DE TIM GIOI HAN CAC NHOM
      XMIN=X(1)
	  XMAX=X(1)
	  DO I=2,N
	     IF (X(I).LT.XMIN) XMIN=X(I)
		 IF (X(I).GT.XMAX) XMAX=X(I)
	  ENDDO
C
      XMIN=AINT(XMIN)
	  IF (XMIN.LT.0.0) XMIN=XMIN-1.0
	  XMAX=AINT(XMAX)
	  IF (XMAX.GT.0.0) XMAX=AINT(XMAX)+1.0
C
      STEP=(XMAX-XMIN)/REAL(M)
C  NEU MUON CHON BUOC TRON SO THI THEM DONG LENH SAU
C
	STEP=AINT(STEP)+1
C
C  TINH XC
      XC(1)=XMIN+STEP/2.0
	DO J=2,M
	   XC(J)=XC(J-1)+STEP
	ENDDO
C  TINH TAN SO CAC KHOANG VA HAM PHAN BO, HAM MAT DO
      STEP=STEP/2.0
	DO J=1,M
	   NFR(J)=0.0
	   DO I=1,N
	      IF ((X(I).GE.XC(J)-STEP).AND.(X(I).LT.XC(J)+STEP)) THEN
	         NFR(J)=NFR(J) + 1
	      ENDIF
	   ENDDO
	   FR(J)=NFR(J)/REAL(N)
	ENDDO
	STEP=STEP*2.0
	DO J=M,1,-1
	   F(J)=FR(J)/STEP
	   TEMP=0.0
	   DO K=1,J
	      TEMP=TEMP+FR(K)
	   ENDDO
	   FR(J)=TEMP
	ENDDO
	RETURN
	END

C
      FUNCTION PROB(FR,XCC,M,STEP,X0)
C
C HAM NAY TINH UOC LUONG XAC SUAT P(X<X0) TU HAM PHAN BO FR
C INPUT: + FR MANG CHUA TAN SUAT TICH LUY DO DAI M
C        + XC MANG CHUA TRI SO GIUA CAC NHOM DO DAI M
C        + M SO NHOM
C        + STEP CU LY NHOM (BUOC)
C        + X0 GIA TRI UNG VOI XAC SUAT CAN TINH P(X<X0)
C OUTPUT: + XAC SUAT P(X<X0)
C
	DIMENSION FR(M),XC(M),XCC(M)
	REAL STEP, X0
	INTEGER M,J
	XC=XCC
	IF (X0.LE.(XC(1)-STEP/2.0)) THEN
	   PROB=0.0
	   RETURN
      ELSE IF (X0.GE.(XC(M)+STEP/2.0)) THEN
	   PROB=1.0
	   RETURN
	ENDIF
C TIM NHOM CHUA X0
      DO J=1,M
	   XC(J)=XC(J)+STEP/2.0
         IF (XC(J).GE.X0) GOTO 20
	ENDDO
  20  PROB=FR(J-1)+(X0-XC(J-1))*(FR(J)-FR(J-1))/(XC(J)-XC(J-1))
	RETURN
	END
C
	FUNCTION X_ALFA(FR,XC,M,STEP,F0)
C
C HAM NAY TINH UOC LUONG TRI SO X0 KHI CHO TRUOC P(X<X0)=F0
C INPUT: + FR MANG CHUA TAN SUAT TICH LUY DO DAI M
C        + XC MANG CHUA TRI SO GIUA CAC NHOM DO DAI M
C        + M SO NHOM
C        + STEP CU LY NHOM (BUOC)
C        + F0=P(X<X0)=F(X0)
C OUTPUT: + TRI SO X0 UNG VOI P(X<X0)=F0
C
	DIMENSION FR(M),XC(M)
	REAL STEP, F0
	INTEGER M,J
C
	IF (F0.LE.0.0.OR.F0.GT.1.0) THEN
	    WRITE(*,*)' INVALID NUMERIC INPUT IN X_ALFA FUNCTION'
	    STOP
	ENDIF
	DO J=2,M
	   XC(J)=XC(J)+STEP/2.0
	   IF(FR(J).GE.F0) GOTO 20
	ENDDO
 20   X_ALFA=XC(J-1)+(F0-FR(J-1))/(FR(J)-FR(J-1))*(XC(J)-XC(J-1))
      RETURN
	END
