	PROGRAM BT3_3
      PARAMETER (NMAX=100)
	DIMENSION X(NMAX),X1(0:NMAX),PX(0:NMAX),FX(0:NMAX)
	DIMENSION P(0:NMAX),F(0:NMAX)  !  CHUA PHAN BO THUC NGHIEM
	INTEGER N,N1,I,J, NAM(NMAX)
	REAL LAMDA

	OPEN(1,FILE='C:\MASTER\G_TR\BAITAP~1\NEW\BANG9.TXT')
	READ(1,*)
	READ(1,*)
	READ(1,*)N
      READ(1,*)((NAM(I),X(I)), I=1,N)

! TINH TRUNG BINH SO LAN XUAT HIEN (LAMDA)
	LAMDA=AMMGOC(X,N,1)

	N1=12   ! THAM SO N CUA PHAN BO
! TINH MAT DO VA PHAN BO THUC NGHIEM
	DO J=0,N1
	   P(J)=0.0
	   DO I=1,N
	      IF (X(I).EQ.J) P(J)=P(J)+1.0
	   ENDDO
	   P(J)=P(J)/REAL(N)
	ENDDO
	DO J=0,N1
	   F(J)=0.0
	   DO I=0,J
	      F(J)=F(J)+P(I)
	   ENDDO
	ENDDO
	CALL POSSD(N1,LAMDA,X1,PX,FX)
	WRITE(*,*)'   HAM MAT DO VA HAM PHAN BO POSSION'
	WRITE(*,'("  LAMDA = ",F8.4,"   N = ",I4)') LAMDA,N1
	WRITE(*,'("  x   ",15F5.0)') (X1(I),I=0,N1)
	WRITE(*,'(" f(x) ",15F5.2)') (PX(I),I=0,N1)
	WRITE(*,'("fn(x) ",15F5.2)') (P(I),I=0,N1)
	WRITE(*,'(" F(x) ",15F5.2)') (FX(I),I=0,N1)
	WRITE(*,'("Fn(x) ",15F5.2)') (F(I),I=0,N1)

	END

	FUNCTION POSSION(LAMDA,K)
	REAL LAMDA
! HAM NAY TINH XAC SUAT SU KIEN XUAT HIEN K LAN THEO POSSION
	  POSSION=EXP(-LAMDA)*LAMDA**K/FAC(K)
	RETURN
	END

	SUBROUTINE POSSD(N,LAMDA,X,PX,FX)
! CHUONG TRINH NAY TINH PHAN BO POSSION
! INPUT: + N SO LAN THI NGHIEM
!        + LAMDA TRUNG BINH SO LAN XUAT HIEN
! OUTPUT: + X MANG DO DAI N+1 (TU 0..N) CHUA GIA TRI CUA X
!         + PX MANG DO DAI N+1 (TU 0..N) CHUA XAC SUAT
!           DE X NHAN CAC GIA TRI 0..N
!         + FX MANG DO DAI N+1 (TU 0..N) CHUA XAC SUAT TICH
!           LUY CUA X (FX(K)=P(X<K))
	DIMENSION X(0:N),PX(0:N),FX(0:N)
	REAL LAMDA

	  DO K=0,N
	     X(K)=K
		 PX(K)=POSSION(LAMDA,K)
	  ENDDO
	  DO K=0,N
	     FX(K)=0.0
	     DO I=0,K
		   FX(K)=FX(K)+PX(I)
	     ENDDO
      ENDDO
	RETURN
	END

	  FUNCTION AMMGOC(X,N,K)
!
! HAM NAY TINH MOMEN GOC BAC K CUA CHUOI SO LIEU
! INPUT: + X MANG SO LIEU BAN DAU DO DAI N
!        + N DUNG LUONG MAU
!        + K BAC CUA MOMEN
! OUTPUT: MOMEN GOC BAC K
!
      DIMENSION X(N)
	  INTEGER N,K,I
	  REAL TMP
	  TMP=0.0
	  DO I=1,N
	     TMP=TMP+X(I)**K
	  ENDDO
	  AMMGOC=TMP/REAL(N)
	  RETURN
	  END

	  FUNCTION FAC(N)
! TINH N! (N GIAI THUA)
	  REAL TMP
	  IF (N.LT.0) THEN
	     WRITE(*,*)' INVALID NUMERIC INPUT IN FAC FUNCTION'
		 STOP
	  ELSE IF (N.EQ.0.OR.N.EQ.1) THEN
	     FAC=1.0
		 RETURN
	  ELSE
	     TMP=1.0
		 DO I=2,N
	        TMP=TMP*REAL(I)
		 ENDDO
		 FAC=TMP
		 RETURN
	  ENDIF
	  END
