	PROGRAM BT_4_17
	PARAMETER (MMAX=100,NMAX=100)
	DIMENSION X(MMAX),Y(NMAX),Z(NMAX+MMAX)
	INTEGER T(NMAX+MMAX)
	INTEGER N,M,I,J,NT,NTX,NTY
	REAL U,V,MUY,XICMA,ALFA,UALFA
	CHARACTER*15 H0,H1,ANSWER1,ANSWER2

	DATA ALFA /0.05/
	DATA H0,H1 /'CHAP NHAN H0','BAC BO H0'/

	OPEN(1,FILE='C:\MASTER\G_TR\BAITAP~1\NEW\BANG13.TXT')
	READ(1,*)
	READ(1,*)M
	READ(1,*)(X(I),I=1,M)
	READ(1,*)
	READ(1,*)N
	READ(1,*)(Y(I),I=1,N)

! GHEP HAI CHUOI VAO MOT (Z) VA TAO CHUOI DANH DAU (T)
	DO I=1,M
	   Z(I)=X(I)
	   T(I)=1
	ENDDO
	K=M
	DO J=1,N
	   K=K+1
	   Z(K)=Y(J)
	   T(K)=2
	ENDDO
! SAP XEP CHUOI DANH DAU UNG VOI CHUOI TRINH TU
	DO I=1,N+M-1
	   DO J=I+1,N+M
	      IF (Z(J).LT.Z(I)) THEN
!	         TMP=Z(J)
!	         Z(J)=Z(I)
!	         Z(I)=TMP
	         NT  =T(J)
	         T(J)=T(I)
	         T(I)=NT
	       ENDIF
	   ENDDO
	ENDDO
! TINH T VA T'
	NTY=0
	NTX=0
	DO I=1,N+M
	   IF (T(I).EQ.2) NTY=NTY+I
	   IF (T(I).EQ.1) NTX=NTX+I
	ENDDO

	MUY=REAL(M*N)/2.0
	XICMA=SQRT(REAL(M*N*(M+N+1))/12.0)

	U=REAL(M*N)+REAL(M*(M+1))/2.0-REAL(NTY)
	V=REAL(M*N)+REAL(N*(N+1))/2.0-REAL(NTX)
	WRITE(*,'("   U  = ",F10.3)') U
	WRITE(*,'("   V  = ",F10.3)') V
	IF (U.LT.V) THEN
	   U=(U-MUY)/XICMA
	ELSE
	   U=(V-MUY)/XICMA
	ENDIF
	UALFA=ANINV(1.0-ALFA/2.0,0.0,1.0)

	IF (ABS(U).LT.UALFA) THEN 
	   ANSWER1=H0
	ELSE
	   ANSWER1=H1
	ENDIF
	WRITE(*,*)' KET QUA KIEM NGHIEM U PHI THAM SO:'
	WRITE(*,*)'      H0: HAI CHUOI DONG NHAT'
	WRITE(*,'("     N1  = ",I10)') M
	WRITE(*,'("     N2  = ",I10)') N
	WRITE(*,'("      U  = ",F10.3)') U
	WRITE(*,'("   ALFA  = ",F10.3)') ALFA
	WRITE(*,'("  UALFA  = ",F10.3)') UALFA
	WRITE(*,'(" KET LUAN: ",A15)') ANSWER1

	END

	FUNCTION ANORMD(AMUY,XICMA,A,B)
! HAM NAY TINH XAC SUAT DE BIEN NGAU NHIEN PHAN BO CHUAN
! NHAN GIA TRI TRONG KHOANG (A,B): P(A<X<B). THUC CHAT
! HAM NAY LA TINH TICH PHAN TU A-B
! INPUT: + MUY KY VONG TOAN
!        + XICMA DO LECH BINH PHUONG TRUNG BINH
!        + A VA B LA HAI CAN TICH PHAN.
! OUTPUT: P(A<X<B)
!
	  REAL AMUY,XICMA,A,B,C
	  PARAMETER(PI=3.1415927,EP=1.0E-6)
	  F(X)=1.0/(SQRT(2.0*PI)*XICMA)*EXP(-0.5*((X-AMUY)/XICMA)**2)
	  IF (A.EQ.B) THEN
	     ANORMD=0.0
		 RETURN
	  ENDIF
	  IF (A.GT.B) THEN
	     C=A
		 A=B
		 B=C
	  ENDIF
	  S=0.0
	  N=0
  10  N=N+1
      DELX=(B-A)/REAL(N)
	  S1=0.0
	  DO I=0,N-1
	     X=A+DELX*REAL(I)
		 F1=F(X)
		 X=X+DELX
		 F2=F(X)
		 S1=S1+(F1+F2)*DELX/2.0
	  ENDDO
	  SS=ABS((S1-S)/S1)
	  IF (SS.GT.EP) THEN
	     S=S1
		 GOTO 10
	  ENDIF
      ANORMD=S1
	  RETURN
	  END

	FUNCTION ANINV(P,MUY,XICMA)
! HAM NAY TINH GIA TRI X0 CUA BIEN NGAU NHIEN X PHAN BO CHUAN
! VOI HAI THAM SO MUY VA XICMA KHI P(X<X0)=P.
! KHI TINH SE SU DUNG BIEN PHAN BO CHUAN CHUAN HOA
! INPUT: + P XAC SUAT DE X<X0 (P(X<X0)=P)
!        + MUY KY VONG CUA X
!        + XICMA DO LECH BINH PHUONG TRUNG BINH
! OUTPUT: X0
!
	  PARAMETER (EPS=1.0E-6)
	  REAL P,AP,MUY,XICMA,A,B,C,P0
	  INTEGER IFLAG
	  IF (P.EQ.0.0) THEN
	     WRITE(*,*)' THE P VALUE TOO SMALL IN ANINV'
		 STOP
	  ELSE IF (P.EQ.0.5) THEN
	     ANINV=MUY
		 RETURN
	  ENDIF
!
	  IF (P.LT.0.5) THEN
	     AP=0.5-P
		 IFLAG=1
	  ELSE IF (P.GT.0.5) THEN
		 AP=P-0.5
		 IFLAG=0
		 PRINT*,P,A,B
	  ENDIF
	  A=0.0
	  B=6.0
	  C=B
	  PRINT*,P,A,B,C

 10	  P0=ANORMD(0.0,1.0,A,B)
	  SS=(ABS(P0-AP)/AP)
	  IF (SS.GE.EPS) THEN
	     IF (AP.LT.P0) THEN
		    C=B
			B=(A+B)/2.0
			GOTO 10
		  ELSE IF (AP.GT.P0) THEN
			B=(C+B)/2.0
			GOTO 10
		  ENDIF
	  ENDIF
	  A=(C+B)/2.0
	  IF (IFLAG.EQ.1) THEN
 	     ANINV=-A*XICMA+MUY
	  ELSE
         ANINV=A*XICMA+MUY
	  ENDIF
	  RETURN
	  END
