	PROGRAM BT5_3
      PARAMETER (NMAX=100,MMAX=6)
	DIMENSION X(NMAX*MMAX)
	DIMENSION R(MMAX*MMAX),RC(MMAX*MMAX)
	CHARACTER VARNAME(6)*2
	DATA VARNAME /'X1','X2','X3','Y1','Y2','Y3'/
	DATA ALFA /0.05/

	OPEN(1,FILE='C:\MASTER\G_TR\BAITAP~1\NEW\BANG2.TXT')
	READ(1,*)
	READ(1,*)
	READ(1,*) N,M
	DO I=1,N
	   L=(M-1)*N+I
	   READ(1,*) TMP, (X(J),J=I,L,N)
	ENDDO

	CALL CORRE(X,N,M,R)
  300 FORMAT('KHOANG UOC LUONG CUA R(',A2,'-',A2,')=(',
     &        F7.4,';',F7.4')')

	DO J=1,M-1
	   DO K=(J-1)*M+J+1, J*M
	      CALL ULKHOANGR(R(K),ALFA,N,R1,R2)
	      L=MOD(K,M)
	      IF (L.EQ.0) L=6
	      WRITE(*,'(" R(",A2,"-",A2,")=",F7.4)')
     &              VARNAME(J),VARNAME(L), R(K)
	      WRITE(*,300) VARNAME(J),VARNAME(L), R1,R2
	   ENDDO
	ENDDO
	
	
	END
!++++++++++++++++++++++
	SUBROUTINE ULKHOANGR(R,ALFA,N,R1,R2)
! CHUONG TRINH NAY TINH UOC LUONG KHOANG CUA HE SO TUONG QUAN
! (R1, R2) ==> R1<RO<R2
! INPUT: + R HE SO TUONG QUAN MAU
!        + ALFA MUC Y NGHIA
!        + N DUNG LUONG MAU
! OUTPUT: + R1 GIOI HAN DUOI CUA KHOANG
!         + R2 GIOI HAN TREN CUA KHOANG
!
	UALFA=ANINV(1.0-ALFA/2.0,0.0,1.0)
	Z=0.5*LOG((1.0+R)/(1.0-R))
	A=0.5*R/(REAL(N-1))
	B=UALFA/SQRT(REAL(N-3))
	R1=Z-A-B
	R2=Z-A+B
!	PRINT*,Z,A,B,R1,R2
	A=EXP(2.0*R1)
	R1=(A-1.0)/(A+1.0)
	A=EXP(2.0*R2)
	R2=(A-1.0)/(A+1.0)
	RETURN
	END

	SUBROUTINE CORRE(X,N,M,R)
! CHUONG TRINH NAY TINH MA TRAN TUONG QUAN CHUAN HOA
! CUA TAP M BIEN TU SO LIEU BAN DAU CO DUNG LUONG N
! INPUT: + X MANG MOT CHIEU KICH THUOC N*M LUU TRU SO
!          LIEU BAN DAU DANG MA TRAN N HANG M COT
!          (X(1,1), X(2,1),...,X(N,1),X(1,2),...)
!        + N DUNG LUONG MAU
!        + M SO BIEN
! OUTPUT: + R MANG MOT CHIEU KICH THUOC M*M LUU TRU MA TRAN
!            TUONG QUAN CHUAN HOA CUA M BIEN
!
	DIMENSION X(N*M),XX(N,M),R(M*M),TB(M),SX(M)
	K=0
	DO J=1,M
	   TB(J)=0.0
	   SX(J)=0.0
	   DO I=1,N
	      K=K+1
	      TB(J)=TB(J)+X(K)
	      SX(J)=SX(J)+X(K)*X(K)
	      XX(I,J)=X(K)
	   ENDDO
	   TB(J)=TB(J)/REAL(N)
	   SX(J)=SQRT(SX(J)/REAL(N)-TB(J)*TB(J))
!	PRINT*,TB(J),SX(J)
	ENDDO
	JK=0
	DO J=1,M
	   DO K=1,M
	      JK=JK+1
	      R(JK)=0.0
	      DO I=1,N
	         R(JK)=R(JK)+XX(I,J)*XX(I,K)
	      ENDDO
	      R(JK)=R(JK)/REAL(N)-TB(J)*TB(K)
	      R(JK)=R(JK)/(SX(J)*SX(K))
	   ENDDO
	ENDDO
	RETURN
	END

	FUNCTION ANORMD(AMUY,XICMA,A,B)
! HAM NAY TINH XAC SUAT DE BIEN NGAU NHIEN PHAN BO CHUAN
! NHAN GIA TRI TRONG KHOANG (A,B): P(A<X<B). THUC CHAT
! HAM NAY LA TINH TICH PHAN TU A-B
! INPUT: + MUY KY VONG TOAN
!        + XICMA DO LECH BINH PHUONG TRUNG BINH
!        + A VA B LA HAI CAN TICH PHAN.
! OUTPUT: P(A<X<B)
!
	  REAL AMUY,XICMA,A,B,C
	  PARAMETER(PI=3.1415927,EP=1.0E-6)
	  F(X)=1.0/(SQRT(2.0*PI)*XICMA)*EXP(-0.5*((X-AMUY)/XICMA)**2)
	  IF (A.EQ.B) THEN
	     ANORMD=0.0
		 RETURN
	  ENDIF
	  IF (A.GT.B) THEN
	     C=A
		 A=B
		 B=C
	  ENDIF
	  S=0.0
	  N=0
  10  N=N+1
      DELX=(B-A)/REAL(N)
	  S1=0.0
	  DO I=0,N-1
	     X=A+DELX*REAL(I)
		 F1=F(X)
		 X=X+DELX
		 F2=F(X)
		 S1=S1+(F1+F2)*DELX/2.0
	  ENDDO
	  SS=ABS((S1-S)/S1)
	  IF (SS.GT.EP) THEN
	     S=S1
		 GOTO 10
	  ENDIF
      ANORMD=S1
	  RETURN
	  END

	FUNCTION ANINV(P,MUY,XICMA)
! HAM NAY TINH GIA TRI X0 CUA BIEN NGAU NHIEN X PHAN BO CHUAN
! VOI HAI THAM SO MUY VA XICMA KHI P(X<X0)=P.
! KHI TINH SE SU DUNG BIEN PHAN BO CHUAN CHUAN HOA
! INPUT: + P XAC SUAT DE X<X0 (P(X<X0)=P)
!        + MUY KY VONG CUA X
!        + XICMA DO LECH BINH PHUONG TRUNG BINH
! OUTPUT: X0
!
	  PARAMETER (EPS=1.0E-6)
	  REAL P,AP,MUY,XICMA,A,B,C,P0
	  INTEGER IFLAG
	  IF (P.EQ.0.0) THEN
	     WRITE(*,*)' THE P VALUE TOO SMALL IN ANINV'
		 STOP
	  ELSE IF (P.EQ.0.5) THEN
	     ANINV=MUY
		 RETURN
	  ENDIF
!
	  IF (P.LT.0.5) THEN
	     AP=0.5-P
		 IFLAG=1
	  ELSE IF (P.GT.0.5) THEN
		 AP=P-0.5
		 IFLAG=0
!		 PRINT*,P,A,B
	  ENDIF
	  A=0.0
	  B=6.0
	  C=B

 10	  P0=ANORMD(0.0,1.0,A,B)
	  SS=(ABS(P0-AP)/AP)
	  IF (SS.GE.EPS) THEN
	     IF (AP.LT.P0) THEN
		    C=B
			B=(A+B)/2.0
			GOTO 10
		  ELSE IF (AP.GT.P0) THEN
			B=(C+B)/2.0
			GOTO 10
		  ENDIF
	  ENDIF
	  A=(C+B)/2.0
	  IF (IFLAG.EQ.1) THEN
 	     ANINV=-A*XICMA+MUY
	  ELSE
         ANINV=A*XICMA+MUY
	  ENDIF
	  RETURN
	  END
